/**
 * James Devine
 * CS370 Final Project
 * A* Solution to the Rush Hour Puzzle
 * 
 * Class to represent a rush hour board state
 * modified extensivly from code provided in class
 */

import java.util.*;


public class Board {
 /** 
  * String array that represents a game board
  */
 private String[][] board;
 
   /**
   * Game board constructor
   */
  public Board(String[][] b) {
    board = new String[b.length][b[0].length];
    for (int row = 0; row < b.length; row++)
      for (int col = 0; col < b[0].length; col++)
        board[row][col] = b[row][col];
  }

  /**
   * Hueristic that measures # of blocked spaces
   */
  public int h() {
    int sum = 0;
    //find last g
	 int gloc=0;
	 for(int i=0;i<6;i++)
		 if(board[2][i]=="g")
			 gloc=i;
    for(int i=gloc+1;i<6;i++)
    	if(board[2][i]!="g" && board[2][i]!=" ")
    		sum++;
    
    return sum;
  }

  /**
   * Returns all possible moves
   */
  public ArrayList<Board> moves() {
    ArrayList<Board> result = new ArrayList<Board>();
    //find horizontal moves
    for(int row=0;row<6;row++)	
	{
		int col=0;
		while(col<6)
	   	{
	   		String temp=board[row][col];
    		if (temp!=" ")
	    		{
	    			//find length of vertical car
	    			int len=1;
	    			while(col+len<6 && board[row][col+len]==temp)
	    			len++;
	    		//if length is greater then 1 its a vertical car...
	    		if(len>1)
	    		{
	    			//System.out.println("length "+len);
	   				//check space before car
	   				int spaceBefore=0;
	   				while(col-spaceBefore-1>=0 && board[row][col-spaceBefore-1]==" ")
    					spaceBefore++;
	   					//System.out.println("Space before "+spaceBefore);
	   				
	    					
	    					for(int i=0;i<spaceBefore;i++)
	    					{
	    						String[][]tempboard=this.copy();
	    						for(int k=0;k<=i;k++)
	    						{
	    							tempboard[row][col+len-1-k]=" ";
	    							tempboard[row][col-1-k]=temp;
	    						}
	    						result.add(new Board(tempboard));
	    					}
	    			
	    			//check space after car
	    			int spaceAfter=0;
	    			while(col+len+spaceAfter<6 && board[row][col+len+spaceAfter]==" ")
	   					spaceAfter++;
	   					//System.out.println("space after "+spaceAfter+"\n");
	   		
	   					for(int i=0;i<spaceAfter;i++)
	   					{
	   						String[][]tempboard=this.copy();
	   						for(int k=0;k<=i;k++)
	   						{
	   							tempboard[row][col+k]=" ";
	   							tempboard[row][col+len+k]=temp;
	   						}
	    						result.add(new Board(tempboard));
	    						
	   						
	   					}
	    				
	    			} 	
	    		col+=len;
	   		}
    		else
    			col+=1;
	   	}
	}
    	//find vertical moves
    	for(int col=0;col<6;col++)	
    	{
    		int row=0;
    		while(row<6)
    	   	{
    	   		String temp=board[row][col];
        		if (temp!=" ")
   	    		{
   	    			//find length of vertical car
   	    			int len=1;
   	    			while(row+len<6 && board[row+len][col]==temp)
    	    			len++;
    	    		//if length is greater then 1 its a vertical car...
    	    		if(len>1)
    	    		{
    	    			//System.out.println("length "+len);
    	   				//check space before car
    	   				int spaceBefore=0;
    	   				while(row-spaceBefore-1>=0 && board[row-spaceBefore-1][col]==" ")
        					spaceBefore++;
    	   					//System.out.println("Space before "+spaceBefore);
    	   				
   	    					
   	    					for(int i=0;i<spaceBefore;i++)
   	    					{
   	    						String[][]tempboard=this.copy();
   	    						for(int k=0;k<=i;k++)
   	    						{
   	    							tempboard[row+len-1-k][col]=" ";
   	    							tempboard[row-1-k][col]=temp;
   	    						}
   	    						result.add(new Board(tempboard));
   	    					}
    	    			
    	    			//check space after car
    	    			int spaceAfter=0;
    	    			while(row+len+spaceAfter<6 && board[row+len+spaceAfter][col]==" ")
    	   					spaceAfter++;
    	   					//System.out.println("space after "+spaceAfter+"\n");
    	   		
    	   					for(int i=0;i<spaceAfter;i++)
    	   					{
    	   						String[][]tempboard=this.copy();
    	   						for(int k=0;k<=i;k++)
    	   						{
    	   							tempboard[row+k][col]=" ";
    	   							tempboard[row+len+k][col]=temp;
    	   						}
   	    						result.add(new Board(tempboard));
   	    						
    	   						
    	   					}
   	    				
   	    			} 	
    	    		row+=len;
    	   		}
        		else
	    			row+=1;
    	   	}
    	}
    return result;
  }
        
  /**
   * Copies an array
   */ 
  private String[][] copy() {
    String[][] b = new String[board.length][board[0].length];
    for (int row = 0; row < board.length; row++)
      for (int col = 0; col < board[0].length; col++)
         b[row][col] = board[row][col];
    return b;
  }

  /**
  *boolean to determine if the board is at a goal state
  */
 public boolean isGoal()
 {
	 boolean temp=true;
	 //find last g
	 int gloc=0;
	 for(int i=0;i<6;i++)
		 if(board[2][i]=="g")
			 gloc=i;
	 //if there is not all spaces after the g's return false
	 for(int i=gloc+1;i<6;i++)
		 if(board[2][i]!=" ")
			 temp=false;
	 return temp;
 }
  /**
   * returns a deep hash of the board
   */
  public int hash()
  {
	  return Arrays.deepHashCode(board);
  }
  
  public String toString() {
    String result = "";
    for (int row = 0; row < board.length; row++)
    {
      for (int col = 0; col < board[0].length; col++)
         result += board[row][col]+" ";
      result+="\n";
    }
    return result + "\n";
  }
}
