/**
 * James Devine
 * CS370 Final Project
 * A* Solution to the Rush Hour Puzzle
 * 
 * Class to create a solution tree
 * modified from code provided in class
 */

public class Node<Board> {
  private Board config; // a game board state
  private int id;   // a unique identifier
  private Node<Board> parent; // parent node in the A* search graph
  private int g, h; // costs to and from this node

  // Constructor:
  public Node(int id, Board config, Node<Board> parent, int h, int cost) {
    this.id = id;
    this.config = config; // Warning! do we want copy or just pointer?
    this.parent = parent;
    this.h= h;
    if (parent == null)
      this.g = 0;
    else
      this.g = parent.g() + cost;
    h = 1;
  }

  // Mutator method -- sets the h value for this node:
  public void setH(int h) {
    this.h = h;
  }

  // Accessor
  public int h() {
    return h;
  }

  // Accessor
  public int g() {
    return g;
  }

  // Accessor
  public int id() {
    return id;
  }

  // Accessor
  public Board config() {
    return config;
  }
  
/**
  * method to print out a solution tree
  */
  public String treePrint()
  {
	  String temp=toString();
	  Node par=this;
	  int count=1;
	  while( par.parent!=null)
	  {
		  count++;
		  par=par.parent;
		  temp+=par.toString();
	  }
	  
	  temp+=("\n This took "+count+" moves to find.");
	  return temp;
  }
  
  public String toString() {
	  return config.toString();
  }
}
