/*
 * James Devine
 * CS370 Final Project
 * A* Solution to the Rush Hour Game
 * 
 * Driver program
 * 
 * Takes an integer command line argument from 1-10
 * representing a puzzle to solve, if no argument provided it uses
 * a default easy puzzle
 * 
 * prints out the board configurations starting with the solution and then
 * progressing toward the initial board configuration
 */

import java.util.*;

public class traffic
{

    public static void main(String[]args)
    {
    	
    	
    	//use a simple board if no command line argument is given
    	String[][]config={{" "," "," "," "," "," "},
    					  {" "," "," ","b"," "," "},
    					  {"g","g","a","b"," "," "},
    					  {" "," ","a"," "," "," "},
    					  {" "," ","a"," "," "," "},
    					  {" "," "," "," "," "," "}};
    	
    	
    	//make the board
    	//g's represent the car trying to exit
    	//all other letters represent cars in the way
    	//if a parameter is given pick a more interesting board
    	if(args.length>0)
    	{
    		String conf=args[0];
       		if (conf.equalsIgnoreCase("1"))	
       		{
       			String[][]config2={{" "," "," ","c","c","c"},
       							   {" "," "," ","b"," "," "},
       							   {"g","g","a","b"," "," "},
       							   {" "," ","a"," "," "," "},
       							   {" "," ","a"," "," "," "},
       							   {" "," "," "," "," "," "}};
       			config=config2;
       		}
       		if(conf.equalsIgnoreCase("2"))
       		{
       			String[][]config2= {{" ","e","e","e"," "," "},
       								{" "," "," ","b"," "," "},
       								{"g","g","a","b","c","d"},
       								{" "," ","a"," ","c","d"},
       								{" "," ","a"," "," ","d"},
       								{" "," "," "," "," "," "}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("3"))
       		{
       			String[][]config2= {{" ","e","e","e"," "," "},
       								{" "," "," ","b"," "," "},
       								{"g","g","a","b","c","d"},
       								{" "," ","a"," ","c","d"},
       								{" "," ","a"," "," ","d"},
       								{" "," ","f","f"," "," "}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("4"))
       		{
       			String[][]config2= {{" ","e","e","e"," "," "},
       								{" "," "," ","b"," "," "},
       								{"g","g","a","b","c","d"},
       								{" "," ","a"," ","c","d"},
       								{" "," ","a"," "," ","d"},
       								{" "," "," ","f","f","f"}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("5"))
       		{
       			String[][]config2= {{" ","e","e","e","c"," "},
       								{" "," "," "," ","c"," "},
       								{"g","g","a"," ","c","d"},
       								{" "," ","a"," "," ","d"},
       								{" "," ","a"," "," ","d"},
       								{" "," "," ","b","b"," "}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("6"))
       		{
       			String[][]config2= {{" "," "," ","b"," "," "},
       								{" ","e"," ","b","c"," "},
       								{" ","e","g","g","c","d"},
       								{" ","e","a"," ","c","d"},
       								{" ","e","a"," "," ","d"},
       								{"h","h","h"," "," "," "}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("7"))
       		{
       			String[][]config2= {{" ","e","x","x","x"," "},
       								{" ","e"," "," ","c"," "},
       								{" ","e","g","g","c","d"},
       								{" ","e"," ","a","a","d"},
       								{" ","e"," "," "," ","d"},
       								{"h","h","h"," "," "," "}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("8"))
       		{
       			String[][]config2= {{"a","a","b"," "," "," "},
       								{" "," ","b"," ","c","c"},
       								{"f","h","g","g","d","e"},
       								{"f","h","i","i","d","e"},
       								{" "," ","j"," "," "," "},
       								{"k","k","j"," "," "," "}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("9"))
       		{
       			String[][]config2= {{"a","a","a","b"," "," "},
       								{" "," ","d","b","c","c"},
       								{"g","g","d"," "," "," "},
       								{"j","k","d","e","e","f"},
       								{"j","k","l","l","l","f"},
       								{"i","i","h","h"," ","f"}};
       		config=config2;
       		}
       		if(conf.equalsIgnoreCase("10"))
       		{
       			String[][]config2= {{" ","a","b"," ","c","c"},
       								{" ","a","b"," "," "," "},
       								{"g","g","b"," "," "," "},
       								{"j","k","k","e","e","d"},
       								{"j","l","l","h","f","d"},
       								{"i","i","i","h","f","d"}};
       		config=config2;
       		}
    	}
    
    	
    	//initialize the begining board
    	Board begin=new Board(config);
    	
    	//priority queue using h value for proritization
    	PriorityQueue<Node> pq = new PriorityQueue<Node>(20,
    	        new Comparator<Node>() {
    	          public int compare(Node i, Node j) {
    	            return  i.h() - j.h();
    	          }
    	        }
    	    );
    	
    	//index number
    	int i=0;
    	
    	//hash code table to make sure same board is not explored more then once
    	ArrayList<Integer>visited=new ArrayList<Integer>();
    	
    	//make the start node and add to the priority queue
    	Node <Board> start=new Node (i, begin,null,begin.h(),0);
    	pq.add(start);
    	
    	//intialize solution to null
    	Node <Board>solution=null;
    	boolean solved=false;
    	
    	//start A* search
    	while(pq.peek()!=null && !solved)
    	{
    		Node <Board>current=pq.poll();
    		visited.add(current.config().hash());
    		if(current.config().isGoal())
    		{
    			solution=current;
    			solved=true;
    		}
    	    Board temp=current.config();
    		for (Board x: temp.moves())
    		{
    			if (!visited.contains(x.hash()))
    			{
    				i++;
    				pq.add(new Node(i,x,current,x.h(),1));
    				visited.add(x.hash());   				
    			}
    		}
    	}
    	//if queue is empty then there is no solution
    	if(pq.peek()==null)
    		System.out.println("No solution");
    	//else there was a solution -print it!
    	else
    		System.out.println(solution.treePrint());
    }
}